<?php

define('FT_TEXT_SMALL', 'fldSm');
define('FT_TEXT_MEDIUM', 'fldMd');
define('FT_TEXT_LARGE', 'fldLg');
define('FT_TEXT_AREA', 'fldT');
define('FT_DATE', 'fldDate');
define('FT_NUMBER', 'fldN');
define('FT_DAY', 'fldDay');
define('FT_MONTH', 'fldMon');
define('FT_YEAR', 'fldYr');
define('FT_TERMS', 'fldTerms');

function selectField($nm, $options, $def, $cls)
{
  echo '<select name="'.$nm.'" class="'.$cls.'">';
  foreach ($options as $val => $label) {
    $sel = ($def == $val) ? ' selected="true"' : '';
    echo '<option value="'.$val.'"'.$sel.'>'.$label.'</option>';
  }
  echo '</select>';
}

function addrange($a, $rfrom, $rto)
{
  $d = ($rfrom > $rto) ? -1 : 1;
  for ($i = $rfrom; $i != $rto; $i += $d) {
    $a[$i] = $i;
  }
  return $a;
}

function formField($nm, $def, $type)
{
  switch ($type) {
    case FT_TEXT_AREA:
      echo '<textarea name="'.$nm.'" class="'.$type.'" rows="5" cols="50">'.$def.'</textarea>';
      break;
    case FT_DATE:
      $def = explode('/', $def);
      while (count($def) < 3) {
        $def[] = '';
      }
      formField($nm.'d', $def[0], FT_DAY); echo ' ';
      formField($nm.'m', $def[1], FT_MONTH); echo ' ';
      formField($nm.'y', $def[2], FT_YEAR);
      break;
    case FT_DAY:
      $options = addrange(array('' => ''), 1, 31);
      selectField($nm, $options, $def, $type);
      break;
    case FT_MONTH:
      $options = array('' => '');
      for ($m = 1; $m <= 12; $m++) {
        $options[$m] = date('M', mktime(0, 0, 0, $m, 1, 2000));
      }
      selectField($nm, $options, $def, $type);
      break;
    case FT_YEAR:
      $options = addrange(array('' => ''), idate('Y'), 1900);
      selectField($nm, $options, $def, $type);
      break;
    case FT_TERMS:
      $chk = $def ? ' checked' : '';
      echo '<iframe src="terms.html" class="'.$type.'" frameborder=0></iframe>';
      echo '<br/><input type="checkbox" name="'.$nm.'" class="'.$type.'" '.$chk.'/>'
        .' I have read, and agree to, the above terms and conditions.';
      break;
    default:
      echo '<input type="text" name="'.$nm.'" value="'.$def.'" class="'.$type.'"/>';
  }
}

function formBegin($id, $formaction)
{
  echo '<form id="'.$id.'" action="'.$formaction.'" method="POST">';
}

function formEnd()
{
  echo '</form>';
}

function formRow($nm, $label, $def, $cls)
{
  if (empty($label)) {
    return;
  }
  echo '<div class="row"><div class="label">'.$label.':</div>';
  echo '<div class="fld">';
  formField($nm, $def, $cls);
  echo '</div></div>';
}

function formMsg($msg)
{
  echo '<div class="row"><div class="label">&nbsp;</div>'
  	.'<div class="">'.$msg.'</div></div>';
}

function formButtons($labels)
{
  echo '<div class="row"><div class="label">&nbsp;</div><div class="btns">';
  foreach ($labels as $label) {
    echo '<input name="action" type="submit" value="'.$label.'" class="btn"/>';
  }
  echo '</div></div>';
}

function formPgButtons($nbuttons, $pg)
{
  echo '<div class="row"><div class="label">&nbsp;</div><div class="btns">';
  for ($i = 1; $i <= $nbuttons; $i++) {
    $dis = ($i == $pg) ? ' disabled' : '';
    echo '<input name="pg" type="submit" value="'.$i.'" class="pgbtn"'.$dis.'/>';
  }
  echo '</div></div>';
}

function formButton($label)
{
  formButtons(array($label));
}

function formHidden($name, $val)
{
  echo '<input type="hidden" name="'.urlencode($name).'" value="'.urlencode($val).'">';
}

?>